//+------------------------------------------------------------------+
//|                                       SpearmanRankCorrMatrix.mq4 |
//|                                      Copyright  2011, LenIFCHIK |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, LenIFCHIK"

#property show_inputs

extern string Symb1="EURUSD";
extern string Symb2="GBPUSD";
extern string Symb3="USDCHF";
extern string Symb4="USDJPY";
extern string Symb5="AUDUSD";
extern string Symb6="USDCAD";

int start()
  {        
   int      i,                                                     //  ,    ErraySort[30,6]
            j,                                                     //  ,    ErraySort[30,6]
            k,                                                     //  ,    ErrayRank[30,6]
            stf,                                                   //   t- 
            Handle,                                                
            Qnt_Symb;   
   
   double   d1,                                                    //      Symb1/Symb2
            d2,                                                    //      Symb1/Symb3 
            d3,                                                    //      Symb1/Symb4
            d4,                                                    //      Symb1/Symb5
            d5,                                                    //      Symb1/Symb6
            d6,                                                    //      Symb2/Symb3
            d7,                                                    //      Symb2/Symb4
            d8,                                                    //      Symb2/Symb5
            d9,                                                    //      Symb2/Symb6
            d10,                                                   //      Symb3/Symb4 
            d11,                                                   //      Symb3/Symb5
            d12,                                                   //      Symb3/Symb6
            d13,                                                   //      Symb4/Symb5
            d14,                                                   //      Symb4/Symb6
            d15;                                                   //      Symb5/Symb6      
   
   double   cor1,                                                  //   Symb1/Symb2
            cor2,                                                  //   Symb1/Symb3 
            cor3,                                                  //   Symb1/Symb4
            cor4,                                                  //   Symb1/Symb5
            cor5,                                                  //   Symb1/Symb6
            cor6,                                                  //   Symb2/Symb3
            cor7,                                                  //   Symb2/Symb4
            cor8,                                                  //   Symb2/Symb5
            cor9,                                                  //   Symb2/Symb6
            cor10,                                                 //   Symb3/Symb4 
            cor11,                                                 //   Symb3/Symb5
            cor12,                                                 //   Symb3/Symb6
            cor13,                                                 //   Symb4/Symb5
            cor14,                                                 //   Symb4/Symb6
            cor15;                                                 //   Symb5/Symb6                         
   
   double   stt1,                                                  //  t-   Symb1/Symb2
            stt2,                                                  //  t-   Symb1/Symb3 
            stt3,                                                  //  t-   Symb1/Symb4
            stt4,                                                  //  t-   Symb1/Symb5
            stt5,                                                  //  t-   Symb1/Symb6
            stt6,                                                  //  t-   Symb2/Symb3
            stt7,                                                  //  t-   Symb2/Symb4
            stt8,                                                  //  t-   Symb2/Symb5
            stt9,                                                  //  t-   Symb2/Symb6
            stt10,                                                 //  t-   Symb3/Symb4 
            stt11,                                                 //  t-   Symb3/Symb5
            stt12,                                                 //  t-   Symb3/Symb6
            stt13,                                                 //  t-   Symb4/Symb5
            stt14,                                                 //  t-   Symb4/Symb6
            stt15;                                                 //  t-   Symb5/Symb6
            
   datetime St1=iTime(Symb1,Period(),i),                           //    i-   Symb1 
            St2=iTime(Symb2,Period(),i),                           //    i-   Symb2
            St3=iTime(Symb3,Period(),i),                           //    i-   Symb3
            St4=iTime(Symb4,Period(),i),                           //    i-   Symb4
            St5=iTime(Symb5,Period(),i),                           //    i-   Symb5
            St6=iTime(Symb6,Period(),i);                           //    i-   Symb6

//----          
   for(i=0; i<=119; i++)                                           // 120          
      {        
         double ErraySort[120,6];                                  //  (120 , 6 )      
         ErraySort[i,0]=iClose(Symb1,Period(),i);                  // 1         
         ErraySort[i,1]=iClose(Symb2,Period(),i);                  // 2 
         ErraySort[i,2]=iClose(Symb3,Period(),i);                  // 3          
         ErraySort[i,3]=iClose(Symb4,Period(),i);                  // 4 
         ErraySort[i,4]=iClose(Symb5,Period(),i);                  // 5                         
         ErraySort[i,5]=iClose(Symb6,Period(),i);                  // 6           
      }                                                                    

//----    ""
   int top=119;                                                    //       
   double temp;                                                    //     ""
   while(top!=0)
      {
         for(i=0;i<top;i++)                                        //     
            {
               for(j=0;j<=5;j++)                                   //     
                  {               
                     if(ErraySort[i,j]>ErraySort[i+1,j])           //     ,  
                        {
	                       temp=ErraySort[i,j];
	                       ErraySort[i,j]=ErraySort[i+1,j];         //     ,... 
	                       ErraySort[i+1,j]=temp;                   //   - 
                        }         
                  }
            }
         top--;
      }                                                          

//----        
   for(k=0; k<=119; k++)   
      {
         double ErrayRank[120,6];                                  //  (120 , 6 )      
         ErrayRank[k,0]=iClose(Symb1,Period(),k);                  // 1         
         ErrayRank[k,1]=iClose(Symb2,Period(),k);                  // 2 
         ErrayRank[k,2]=iClose(Symb3,Period(),k);                  // 3          
         ErrayRank[k,3]=iClose(Symb4,Period(),k);                  // 4 
         ErrayRank[k,4]=iClose(Symb5,Period(),k);                  // 5                         
         ErrayRank[k,5]=iClose(Symb6,Period(),k);                  // 6           
      }  

//----     ErrayRank  
   for(k=0; k<=119; k++)                                           //     ErraySort
      {
         for(i=0; i<=119; i++)                                     //     ErrayRank   
            {        
               for(j=0;j<=5;j++)                                   //                                          
                  {               
                     if(ErrayRank[k,j]==ErraySort[i,j])            //   ,...
                        {
                           ErrayRank[k,j]=120-i;                   // ...   ErrayRank  *
                        }                                          // *      ...
                  }                                                // ...    ErraySort
            }     
      }

//----      
   for(k=0; k<=119; k++)   
      {   
         d1+=MathPow(ErrayRank[k,0]-ErrayRank[k,1],2);
         d2+=MathPow(ErrayRank[k,0]-ErrayRank[k,2],2);
         d3+=MathPow(ErrayRank[k,0]-ErrayRank[k,3],2);
         d4+=MathPow(ErrayRank[k,0]-ErrayRank[k,4],2);
         d5+=MathPow(ErrayRank[k,0]-ErrayRank[k,5],2);      
         d6+=MathPow(ErrayRank[k,1]-ErrayRank[k,2],2);
         d7+=MathPow(ErrayRank[k,1]-ErrayRank[k,3],2);
         d8+=MathPow(ErrayRank[k,1]-ErrayRank[k,4],2);
         d9+=MathPow(ErrayRank[k,1]-ErrayRank[k,5],2);
         d10+=MathPow(ErrayRank[k,2]-ErrayRank[k,3],2);  
         d11+=MathPow(ErrayRank[k,2]-ErrayRank[k,4],2);
         d12+=MathPow(ErrayRank[k,2]-ErrayRank[k,5],2);
         d13+=MathPow(ErrayRank[k,3]-ErrayRank[k,4],2);
         d14+=MathPow(ErrayRank[k,3]-ErrayRank[k,5],2);
         d15+=MathPow(ErrayRank[k,4]-ErrayRank[k,5],2);  
      }         

//----                                                                 
   cor1=1-(6*d1/(120*(MathPow(120,2)-1)));   
   cor2=1-(6*d2/(120*(MathPow(120,2)-1)));
   cor3=1-(6*d3/(120*(MathPow(120,2)-1)));
   cor4=1-(6*d4/(120*(MathPow(120,2)-1)));
   cor5=1-(6*d5/(120*(MathPow(120,2)-1)));
   cor6=1-(6*d6/(120*(MathPow(120,2)-1)));
   cor7=1-(6*d7/(120*(MathPow(120,2)-1)));   
   cor8=1-(6*d8/(120*(MathPow(120,2)-1)));
   cor9=1-(6*d9/(120*(MathPow(120,2)-1)));
   cor10=1-(6*d10/(120*(MathPow(120,2)-1)));
   cor11=1-(6*d11/(120*(MathPow(120,2)-1)));
   cor12=1-(6*d12/(120*(MathPow(120,2)-1))); 
   cor13=1-(6*d13/(120*(MathPow(120,2)-1)));   
   cor14=1-(6*d14/(120*(MathPow(120,2)-1)));
   cor15=1-(6*d15/(120*(MathPow(120,2)-1)));

//----    t- 
   double ErrayStf[15,1];                                         //  (15 , 1 )                                  
   ErrayStf[0,0]=MathAbs(cor1)*MathSqrt(118)/MathSqrt(1-MathPow(cor1,2));    
   ErrayStf[1,0]=MathAbs(cor2)*MathSqrt(118)/MathSqrt(1-MathPow(cor2,2));
   ErrayStf[2,0]=MathAbs(cor3)*MathSqrt(118)/MathSqrt(1-MathPow(cor3,2));
   ErrayStf[3,0]=MathAbs(cor4)*MathSqrt(118)/MathSqrt(1-MathPow(cor4,2));
   ErrayStf[4,0]=MathAbs(cor5)*MathSqrt(118)/MathSqrt(1-MathPow(cor5,2));
   ErrayStf[5,0]=MathAbs(cor6)*MathSqrt(118)/MathSqrt(1-MathPow(cor6,2));
   ErrayStf[6,0]=MathAbs(cor7)*MathSqrt(118)/MathSqrt(1-MathPow(cor7,2));   
   ErrayStf[7,0]=MathAbs(cor8)*MathSqrt(118)/MathSqrt(1-MathPow(cor8,2));
   ErrayStf[8,0]=MathAbs(cor9)*MathSqrt(118)/MathSqrt(1-MathPow(cor9,2));
   ErrayStf[9,0]=MathAbs(cor10)*MathSqrt(118)/MathSqrt(1-MathPow(cor10,2));
   ErrayStf[10,0]=MathAbs(cor11)*MathSqrt(118)/MathSqrt(1-MathPow(cor11,2));
   ErrayStf[11,0]=MathAbs(cor12)*MathSqrt(118)/MathSqrt(1-MathPow(cor12,2)); 
   ErrayStf[12,0]=MathAbs(cor13)*MathSqrt(118)/MathSqrt(1-MathPow(cor13,2));   
   ErrayStf[13,0]=MathAbs(cor14)*MathSqrt(118)/MathSqrt(1-MathPow(cor14,2));
   ErrayStf[14,0]=MathAbs(cor15)*MathSqrt(118)/MathSqrt(1-MathPow(cor15,2));   
                                             
//----     t-  ( 118  )   
   string ErrayCp[15,1];                                           //   
   for(i=0;i<=14;i++)
      {
         if(ErrayStf[i,0]>=1.296 && ErrayStf[i,0]<1.671)
            {
               ErrayCp[i,0]=DoubleToStr(80.0,1);   
            }
         else
            {
               if(ErrayStf[i,0]>=1.671 && ErrayStf[i,0]<2.000)
                  {
                     ErrayCp[i,0]=DoubleToStr(90.0,1);   
                  }               
               else
                  {
                     if(ErrayStf[i,0]>=2.000 && ErrayStf[i,0]<2.390)
                        {
                           ErrayCp[i,0]=DoubleToStr(95.0,1);   
                        }               
                     else
                        {
                           if(ErrayStf[i,0]>=2.390 && ErrayStf[i,0]<2.660)
                              {
                                 ErrayCp[i,0]=DoubleToStr(98.0,1);   
                              }
                           else
                              {
                                 if(ErrayStf[i,0]>=2.660 && ErrayStf[i,0]<3.460)
                                    {
                                       ErrayCp[i,0]=DoubleToStr(99.0,1);   
                                    }
                                 else
                                    {
                                       if(ErrayStf[i,0]>=3.460)
                                          {
                                             ErrayCp[i,0]=DoubleToStr(99.9,1);   
                                          }
                                       else
                                          {
                                             ErrayCp[i,0]="insign";  
                                          }
                                    }
                              }
                        }
                  }    
            }
      }                   
//----  -  
   string ErrayCorr[13,7];                                         //  (12 , 7 )      
   //                                                         
   ErrayCorr[0,0]="";     ErrayCorr[0,1]=Symb1;                ErrayCorr[0,2]=Symb2;                ErrayCorr[0,3]=Symb3; 
   ErrayCorr[1,0]=Symb1;  ErrayCorr[1,1]="1";                  ErrayCorr[1,2]="";                   ErrayCorr[1,3]="";
   ErrayCorr[2,0]=Symb2;  ErrayCorr[2,1]=DoubleToStr(cor1,2);  ErrayCorr[2,2]="1";                  ErrayCorr[2,3]="";
   ErrayCorr[3,0]=Symb3;  ErrayCorr[3,1]=DoubleToStr(cor2,2);  ErrayCorr[3,2]=DoubleToStr(cor6,2);  ErrayCorr[3,3]="1";
   ErrayCorr[4,0]=Symb4;  ErrayCorr[4,1]=DoubleToStr(cor3,2);  ErrayCorr[4,2]=DoubleToStr(cor7,2);  ErrayCorr[4,3]=DoubleToStr(cor10,2);
   ErrayCorr[5,0]=Symb5;  ErrayCorr[5,1]=DoubleToStr(cor4,2);  ErrayCorr[5,2]=DoubleToStr(cor8,2);  ErrayCorr[5,3]=DoubleToStr(cor11,2);
   ErrayCorr[6,0]=Symb6;  ErrayCorr[6,1]=DoubleToStr(cor5,2);  ErrayCorr[6,2]=DoubleToStr(cor9,2);  ErrayCorr[6,3]=DoubleToStr(cor12,2);
   ErrayCorr[7,0]="";     ErrayCorr[7,1]="";                   ErrayCorr[7,2]="";                   ErrayCorr[7,3]="";
   ErrayCorr[8,0]=Symb2;  ErrayCorr[8,1]=ErrayCp[0,0];         ErrayCorr[8,2]="";                   ErrayCorr[8,3]="";
   ErrayCorr[9,0]=Symb3;  ErrayCorr[9,1]=ErrayCp[1,0];         ErrayCorr[9,2]=ErrayCp[5,0];         ErrayCorr[9,3]="";
   ErrayCorr[10,0]=Symb4; ErrayCorr[10,1]=ErrayCp[2,0];        ErrayCorr[10,2]=ErrayCp[6,0];        ErrayCorr[10,3]=ErrayCp[9,0];
   ErrayCorr[11,0]=Symb5; ErrayCorr[11,1]=ErrayCp[3,0];        ErrayCorr[11,2]=ErrayCp[7,0];        ErrayCorr[11,3]=ErrayCp[10,0];
   ErrayCorr[12,0]=Symb6; ErrayCorr[12,1]=ErrayCp[4,0];        ErrayCorr[12,2]=ErrayCp[8,0];        ErrayCorr[12,3]=ErrayCp[11,0];
   
   //                                                
   ErrayCorr[0,4]=Symb4;                ErrayCorr[0,5]=Symb5;                ErrayCorr[0,6]=Symb6;
   ErrayCorr[1,4]="";                   ErrayCorr[1,5]="";                   ErrayCorr[1,6]="";
   ErrayCorr[2,4]="";                   ErrayCorr[2,5]="";                   ErrayCorr[2,6]="";
   ErrayCorr[3,4]="";                   ErrayCorr[3,5]="";                   ErrayCorr[3,6]="";
   ErrayCorr[4,4]="1";                  ErrayCorr[4,5]="";                   ErrayCorr[4,6]="";
   ErrayCorr[5,4]=DoubleToStr(cor13,2); ErrayCorr[5,5]="1";                  ErrayCorr[5,6]="";
   ErrayCorr[6,4]=DoubleToStr(cor14,2); ErrayCorr[6,5]=DoubleToStr(cor15,2); ErrayCorr[6,6]="1";
   ErrayCorr[7,4]="";                   ErrayCorr[7,5]="";                   ErrayCorr[7,6]="";
   ErrayCorr[8,4]="";                   ErrayCorr[8,5]="";                   ErrayCorr[8,6]="";                  
   ErrayCorr[9,4]="";                   ErrayCorr[9,5]="";                   ErrayCorr[9,6]="";      
   ErrayCorr[10,4]="";                  ErrayCorr[10,5]="";                  ErrayCorr[10,6]="";     
   ErrayCorr[11,4]=ErrayCp[12,0];       ErrayCorr[11,5]="";                  ErrayCorr[11,6]="";     
   ErrayCorr[12,4]=ErrayCp[13,0];       ErrayCorr[12,5]=ErrayCp[14,0];       ErrayCorr[12,6]="";                                            

   //----    
   for(i=0; i<=119; i++)                                           // 120         
      {                       
         if(St1!=St2) 
            {
               ErrayCorr[2,1]="time inc";
               ErrayCorr[8,1]="time inc";
            }                       
         if(St1!=St3)
            { 
               ErrayCorr[3,1]="time inc";
               ErrayCorr[9,1]="time inc";
            }                                     
         if(St1!=St4) 
            {
               ErrayCorr[4,1]="time inc";
               ErrayCorr[10,1]="time inc";
            }                                   
         if(St1!=St5) 
            {   
               ErrayCorr[5,1]="time inc";                    
               ErrayCorr[11,1]="time inc";
            }         
         if(St1!=St6) 
            {
               ErrayCorr[6,1]="time inc";
               ErrayCorr[12,1]="time inc";               
            }                                                       
         if(St2!=St3) 
            {
               ErrayCorr[3,2]="time inc";
               ErrayCorr[9,2]="time inc";
            }                                      
         if(St2!=St4)
            { 
               ErrayCorr[4,2]="time inc";
               ErrayCorr[10,2]="time inc";
            }                                
         if(St2!=St5)
            { 
               ErrayCorr[5,2]="time inc";
               ErrayCorr[11,2]="time inc";
            }                                   
         if(St2!=St6)
            { 
               ErrayCorr[6,2]="time inc";
               ErrayCorr[12,2]="time inc";
            }                                   
         if(St3!=St4) 
            {
               ErrayCorr[4,3]="time inc";
               ErrayCorr[10,3]="time inc";
            }                                       
         if(St3!=St5)
            { 
               ErrayCorr[5,3]="time inc";
               ErrayCorr[11,3]="time inc";
            }                        
         if(St3!=St6)
            {
               ErrayCorr[6,3]="time inc";
               ErrayCorr[12,1]="time inc";
            }                         
         if(St4!=St5) 
            {
               ErrayCorr[5,4]="time inc";
               ErrayCorr[11,4]="time inc";
            }                         
         if(St4!=St6) 
            {
               ErrayCorr[6,4]="time inc"; 
               ErrayCorr[12,4]="time inc";
            }                                     
         if(St5!=St6)
            { 
               ErrayCorr[6,5]="time inc";
               ErrayCorr[12,5]="time inc";
            }                     
      }

//----     
   Handle=FileOpen("corr\\matrix.csv",FILE_CSV|FILE_WRITE,";");    //  
   if(Handle==-1)                                                  //    
     {
        Alert("   .");                       //    
        return;                                           
     }     
   for(i=0;i<=13;i++)                                              //         
     {      
        //   
        Qnt_Symb=FileWrite(Handle,ErrayCorr[i,0],ErrayCorr[i,1],ErrayCorr[i,2],ErrayCorr[i,3],ErrayCorr[i,4],ErrayCorr[i,5],ErrayCorr[i,6]);                         
        if(Qnt_Symb < 0)                                           //           
               {         
                  Alert("    ",GetLastError());   //                  
                  FileClose(Handle);                               //           
                  return;                                                        
               }     
     }
   FileClose(Handle);                                              //  
   Alert(" matrix.csv .");                               //                                                               
   return(0);  
  }